'' ******************************************************************************
'' * C64 RAM test application                                                   *
'' * James Burrows June 2006                                                    *
'' * Version 1.1                                                                *
'' ******************************************************************************
''
'' This is the demo program for the bigmemobject which allows a propeller
'' to have a 128KB serially accessible RAM block accessed via .writeValue(x)
'' and .readValue(x,y)
''
'' Version 1.0 = release
''         1.1 = changed to readValue & writeValue
''               changed to allow LONG read and writes (vb app changed as well)
''               error handling : if comm failure between VB and Propeller the
''                                readValue routine now times out.
''
'' this object provides the PUBLIC functions:
''  -> Start
''
'' this object provides the PRIVATE functions:
''  -> None
''
'' this object uses the following sub OBJECTS:
''  -> bigmemObject
''

CON
  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000
  _stack        = 50

  LCD_Pin       = 10
  LCD_Baud      = 9600
  LCD_Lines     = 20

  PC_rx         = 31
  PC_tx         = 30

VAR
  long  ramaddress
  long  DataValue

OBJ
  lcdobject           : "lcdObject"
  bigmem              : "bigmemObject"     

PUB Start
  ' init my LCD
  LCDObject.init(LCD_Pin, LCD_Baud, LCD_Lines)
  ' start the full duplex
  datavalue := bigmem.init(PC_rx, PC_tx)

  lcdobject.clearlcd
  lcdobject.changeline(1,string("C64 ram test demo"))

  ' wait here while you start the PC application.... (if using the programming pins 31 and 30)
  ' otherwise it doesn't matter
  waitcnt(400_000_000+cnt)
  
  ' test loop  
  repeat ramaddress from 0 to 1000

     ' write the data
     bigmem.writeValue(ramAddress,10_000_000+ramaddress)

      ' read it back
     lcdobject.changeline(3,string("ADDR:"))
     lcdobject.outputnumber(ramaddress)
     lcdobject.output(" ")
     DataValue := bigmem.readValue(ramAddress) 
     lcdobject.outputnumber(dataValue)

     ' show accuracy test
     if dataValue <> 10_000_000+ramaddress
       lcdobject.changeline(4,string("data error!"))
     else
       lcdobject.changeline(4,string("data OK"))

     ' wait a tick - not needed but slows the loop down so
     ' the LCD can update!         
    waitcnt(5_000_000+cnt)
  
                    

  
  
  